﻿using System;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;

namespace Zzz
{
    public static class Constants
    {
        #region Static Fields and Constants

        public static string ConfigurationXsd = "Configuration.xsd";

        public static string ConfigurationNamespace = "urn:zzz-configuration-schema";

        public static readonly string AssemblyName = Assembly.GetEntryAssembly().GetName().Name;

        public static readonly string AssemblyVersion = Assembly.GetEntryAssembly().GetName().Version.ToString();

        public static readonly string AssemblyGuid =
            ((GuidAttribute) Assembly.GetEntryAssembly().GetCustomAttributes(typeof(GuidAttribute), true)[0]).Value;

        public static string ConfigurationFile => Path.Combine(UserApplicationDirectory, @"Configuration.xml");

        #endregion

        #region Public Enums, Properties and Fields

        public static string UserApplicationDirectory => Path.Combine(
            Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), @"Wizardry and Steamworks", @"Zzz");

        #endregion
    }
}