﻿using System.Collections.Generic;
using System.Xml.Schema;
using Zzz.Utilities.Serialization;

namespace Zzz.Utilities.Serialization
{
    public class SerializationSuccess<T> : SerializationState
    {
        #region Public Enums, Properties and Fields

        public T Result { get; }

        public List<ValidationEventArgs> ValidationEventArgs { get; }

        #endregion

        #region Constructors, Destructors and Finalizers

        public SerializationSuccess()
        {
        }

        public SerializationSuccess(T result) : this()
        {
            Result = result;
        }

        public SerializationSuccess(T result,
                                    List<ValidationEventArgs> validationEventArgs) : this(result)
        {
            ValidationEventArgs = validationEventArgs;
        }

        #endregion
    }
}